SET SQL DIALECT 3;

SET NAMES WIN1251;

CONNECT '' USER 'SYSDBA' PASSWORD 'masterkey';

SET TERM ^ ;

CREATE OR ALTER PROCEDURE "prnSaleInfo" (
    "TransId" integer)
returns (
    "Id" integer,
    "Group" varchar(30),
    "Order" varchar(30),
    "Contr" varchar(30),
    "Driver" varchar(30),
    "Model" varchar(30),
    "Auto" varchar(30),
    "Fuel" varchar(30),
    "VolumeS" varchar(30),
    "Operator" varchar(30),
    "Date" timestamp)
as
declare variable "Volume" numeric(9,2);
begin
 for select nt."NzTransId", g."Name", o."Code",
     c."Name", d."Name", cm."Model", cr."Number",
     f."Name", IIF(nt."DateEnd" > '1.01.1900', nt."Volume", ant."Volume") * 1000,
     u."Name", IIF(nt."DateEnd" > '1.01.1900', nt."DateEnd", 'now')

 from "rgNozzleTransaction" nt

 join "docOrder" o
  on o."OrderId" = nt."OrderId"

 join "docPumpOrder" po
  on po."OrderId" = o."OrderId"

 join  "OrderGroup" g
  on g."OrderGroupId" = o."OrderGroupId"

 left join  "Contractor" c
  on c."ContrId" = po."ContrId"

 left join  "Driver" d
  on d."DriverId" = po."DriverId"

 left join  "Car" cr
  on cr."CarId" = po."CarId"

 left join  "CarModel" cm
  on cm."CarModelId" =   cr."CarModelId"

 join  "User" u
  on u."UserId" = nt."UserId"

 join  "Fuel" f
  on f."FuelId" = nt."FuelId"

 left join "lstActiveNozzleTransaction" ant
  on ant."NzTransId" = nt."NzTransId"

 where nt."NzTransId" = :"TransId"
   into :"Id", :"Group", :"Order", :"Contr", :"Driver", :"Model", :"Auto", :"Fuel",
    :"Volume", :"Operator", :"Date"
   do begin
    "VolumeS" = "Volume";

    suspend;
   end
end^

SET TERM ; ^

GRANT SELECT ON "rgNozzleTransaction" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "docOrder" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "docPumpOrder" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "OrderGroup" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "Contractor" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "Driver" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "Car" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "CarModel" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "User" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "Fuel" TO PROCEDURE "prnSaleInfo";

GRANT SELECT ON "lstActiveNozzleTransaction" TO PROCEDURE "prnSaleInfo";

GRANT EXECUTE ON PROCEDURE "prnSaleInfo" TO SYSDBA;
GRANT EXECUTE ON PROCEDURE "prnSaleInfo" TO OPERATOR;
